//Copyright 2016 J.-M. CHESNEAUX, F. JEZEQUEL, J.-L. LAMOTTE
//
//This file is part of CADNA.
//
//    CADNA is free software: you can redistribute it and/or modify it
//    under the terms of the GNU Lesser General Public License as
//    published by the Free Software Foundation, either version 3 of the
//    License, or (at your option) any later version.
//
//    CADNA is distributed in the hope that it will be useful, but WITHOUT
//    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
//    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General
//    Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with CADNA. If not, see
//    <http://www.gnu.org/licenses/>.
//


#include "cadna.h"
#include "cadna_private.h"


/////////////////////////////////////////////////////////////////////////



complex<double_st> operator*(const double& a,complex<double_st> const& b)  
{  
  complex<double_st> res;  
  res=(double_st)a*b;  
  return res; 
}
 
 
complex<float_st> operator*(const float& a,complex<float_st> const& b)  
{  
  complex<float_st> res;  
  res=(float_st)a*b;  
  return res; 
}
 
 



complex<double_st> operator*(complex<double_st> const& a, double const& b)  
{  
  complex<double_st> res;  
  res=a*(double_st)b;  
  return res; 
}
 
 
complex<float_st> operator*(complex<float_st> const& a, float const& b)  
{  
  complex<float_st> res;  
  res=a*(float_st)b;  
  return res; 
}
 
 

/////////////////////////////////////////////////////////////////////////



complex<double_st> operator/(const double& a,complex<double_st> const& b)  
{  
  complex<double_st> res;  
  res=(double_st)a/b;  
  return res; 
}
 
 
complex<float_st> operator/(const float& a,complex<float_st> const& b)  
{  
  complex<float_st> res;  
  res=(float_st)a/b;  
  return res; 
}
 
 



complex<double_st> operator/(complex<double_st> const& a, double const& b)  
{  
  complex<double_st> res;  
  res=a/(double_st)b;  
  return res; 
}
 
 
complex<float_st> operator/(complex<float_st> const& a, float const& b)  
{  
  complex<float_st> res;  
  res=a/(float_st)b;  
  return res; 
}
 
 

/////////////////////////////////////////////////////////////////////////


complex<double_st> operator+(const double& a,complex<double_st> const& b)  
{  
  complex<double_st> res;  
  res=(double_st)a+b;  
  return res; 
}
 
 
complex<float_st> operator+(const float& a,complex<float_st> const& b)  
{  
  complex<float_st> res;  
  res=(float_st)a+b;  
  return res; 
}
 
 



complex<double_st> operator+(complex<double_st> const& a, double const& b)  
{  
  complex<double_st> res;  
  res=a+(double_st)b;  
  return res; 
}
 
 
complex<float_st> operator+(complex<float_st> const& a, float const& b)  
{  
  complex<float_st> res;  
  res=a+(float_st)b;  
  return res; 
}
 
 

/////////////////////////////////////////////////////////////////////////


complex<double_st> operator-(const double& a,complex<double_st> const& b)  
{  
  complex<double_st> res;  
  res=(double_st)a-b;  
  return res; 
}
 
 
complex<float_st> operator-(const float& a,complex<float_st> const& b)  
{  
  complex<float_st> res;  
  res=(float_st)a-b;  
  return res; 
}
 
 



complex<double_st> operator-(complex<double_st> const& a, double const& b)  
{  
  complex<double_st> res;  
  res=a-(double_st)b;  
  return res; 
}
 
 
complex<float_st> operator-(complex<float_st> const& a, float const& b)  
{  
  complex<float_st> res;  
  res=a-(float_st)b;  
  return res; 
}
 
 
